import { is, isString } from 'ts-type-guards';
import AbstractElement from './AbstractElement';
export default class Input extends AbstractElement {
    constructor() {
        super(...arguments);
        this.placeholder = '';
    }
    /** Sets the placeholder that will be displayed in the field when its empty */
    setPlaceholder(placeholder) {
        this.placeholder = placeholder;
        return this;
    }
    getElementsToAppend() {
        return [this.getInput()];
    }
    propagateValue(value) {
        if (!isString(value)) {
            return;
        }
        this.getInput().value = value;
    }
    getInput() {
        if (!this.input) {
            this.input = document.createElement('input');
            this.input.classList.add('sdpi-item-value');
            this.input.addEventListener('input', (event) => this.onInput(event));
        }
        if (this.placeholder !== '') {
            this.input.placeholder = this.placeholder;
        }
        return this.input;
    }
    onInput(event) {
        if (is(HTMLInputElement)(event.target)) {
            this.changeValue(event.target.value);
        }
    }
}
