/** Fix sdpi-bug, where the range progress is not displayed */
export default class RangeProgress {
    attachListeners(eventEmitter) {
        // initially create the --min/--max/--val properties, so our css calculations work
        eventEmitter.on('create-range', (range) => {
            range.style.setProperty('--min', range.min);
            range.style.setProperty('--max', range.max);
            range.style.setProperty('--val', '0');
        });
        // make sure the --val property is always up-to-date
        eventEmitter.on('update-value', (range, newValue) => range.style.setProperty('--val', newValue));
    }
}
